<?php
#...
function say($txt,$debug=false) {
	global $DEBUG;
	if (($debug&&$DEBUG)||(!$debug))
		echo "[".date("h:i:s")."] $txt\n";
}

#Original code and idea: 
#Beaker, http://tera.kuren.org/basicbot
#print some nice debug infos about the traffic
function verbose_output($type, $args)
{
	global $AOC;
	global $myname;

	// print out a nice output for all the incoming different packet types
	switch ($type)
	{
			case	0: /*Login Seed 	S	 */
				$output .= "[Received login seed, \"$args[0]\"]";
				break;
			case	5: /*Login Result OK	 */
				$output .= "[You are logged in as $myname]";
				$time_of_first_logon=time();
			break;
			case	6: /*Login Result Error 	S	 */
				$output .= "[Login error: $args[0]]";
			break;
			case	7: /*Login CharacterList	isii  */
				$output .= "[List of characters on this account available:]\n";
				$output .= "       online?      Level       Name      CharNum\n";
				for ($i=3;$i>=0;$i--)
				{
					$j=0;
					foreach ($args[$i] as $value)
					{
						$output2[$j] .= sprintf("%12s ",$value);
						$j++;
					}
				}
				foreach ($output2 as $value)
					$output.= "$value\n";
				break;
			case	10: /*Client Unknown	I	 */
				$output .= "[Client Unknown: \"".$args[0]."\"]";
				break;
			case	20: /*Client Name	IS	 */
				#aoc: args-array = char-id , online status , name
				$output .= "[name lookup: $args[0] is \"$args[2]\" ($args[1])]";
				if ($args[4]) $output .= "($args[4])";
				break;
			case	21: /*Lookup Result IS	 */
				$output .= "[$args[0]=$args[1]]";
				break;
			case	30: /*Message Private     ISS*/
				// code for this case was handled before the "switch" command
				break;
			case	34: /*Message Vicinity	ISS  */
				$output .= "$args[0]: $args[1]";
				$blob=$args[2];
				break;
			case	35: /*Message Anon Vicinity SSS  */
				$output .= "[Message Anon Vicinity: ".stripcolors($args[0])." ".stripcolors($args[1])." ".stripcolors($args[2])." ]";
				break;
			case	36: /*Message System	S	 */
				$output .= "[[SYSTEM]] \"$args[0]\"";
				break;
			case	40: /*Buddy Added	IIS  */
				#aoc: args-array = char-id , online status, level , playfield? , class
				$output .= "[Buddy Status: ".$AOC->id[$args[0]];
				$online = 0 + $args[1];
				if ($online==1)
					$output .=" (is online)";
				if ($online==0)
					$output .=" (is offline)";
				$friends_list = 0+$args[4];
				if ($friends_list==1)
					$output .=" (is on your friends list)";
				if ($friends_list==0)
					$output .=" (is on your unknown list)";
				$output .= "(".$args[3].") ";
				$output .= "(".$args[4].") ";
				$output .= "]";
				break;
			case	41: /*Buddy Removed I	 */
				$output .= "[Buddy removed: \"".$AOC->id[$args[0]]."\"]";
				break;
			case	50: /*Privategroup Invited	I	 */
				$output .= "[Invited to join the private channel of: \"".$AOC->id[$args[0]]."\"]";
				break;
			case	51: /*Privategroup Kicked	I	 */
				$output .= "[Kicked from private channel of: \"".$args[0]."]\"";
				break;
			case	53: /*Privategroup Part I	 */
				$output .= "[Privategroup Part: \"".$AOC->id[$args[0]]."\"]";
				break;
			case	55: /*Privategroup Client Join	II	 */
				$output .= "[\"".$AOC->id[$args[1]]."\" joined the private channel of \"".$AOC->id[$args[0]]."\" ]";
				break;
			case	56: /*Privategroup Client Part	II	 */
				$output .= "[\"".$AOC->id[$args[1]]."\" left the private channel of \"".$AOC->id[$args[0]]."\" ]";
				break;
			case	57: /*Privategroup Message    IISS*/
				// code for this case was handled before the "switch" command
				break;
			case	60: /*Group Join	GSIS  */
				$output .= "[Group Join: \"".stripcolors($args[1])."\"]";
				break;
			case	61: /*Group Part	G	 */
				$output .= "[Group Part	G: \"".stripcolors($args[0])."\"]";
				break;
			case	65: /*Group Message   GISS*/
				// code for this case was handled before the "switch" command
				break;
			case  100: /*Pong	S	 */
				#aoc:off	$output .= "[Pong: \"".stripcolors($args[0])."\"]\n";
				break;
			case  110: /*Forward	IM	 */
				$sender=$AOC->id[$args[0]];
				$output .="[$sender did /cc info $myname]";
				break;
			case 1100: /*Adm Mux Info	iii  */
				$output .="[Adm Mux Info:]\n";
				// I have no idea what this is for, so I'll leave it as a print_r and hope I catch it one day
				print_r($args[0]);
				print_r($args[1]);
				print_r($args[2]);
				break;
			default:
				$output .= "[Unknown packet received: type=$type]\n";
	}
	return $output;
}


